#Ifndef textures_t
#Define textures_t
Type texture_t
	Protected:
	Private:
	m_pixdata As UByte Ptr
	m_width As UInteger
	m_height As UInteger
	m_bpp As UInteger
	
	Public:
	Declare Constructor()
	Declare Constructor(w As UInteger,h As UInteger,bpp As uinteger)
	Declare Destructor()
	
	Declare Function 	GetHeight() As UInteger
	Declare Function 	GetWidth() As UInteger
	Declare Function 	GetDepth() As UInteger
	Declare Function 	GetPixData() As UByte Ptr
	Declare Sub			LoadBMP(filenam As string)
	Declare Sub			LoadTGA(filenam As string)
End Type
Constructor texture_t()
m_pixdata=0
m_width=0
m_height=0
m_bpp=0
End Constructor
constructor texture_t(w As UInteger,h As UInteger,bpp As UInteger)
	If m_bpp<8 Then m_bpp=8
	If m_bpp>32 Then m_bpp=32
	If h=0 Then	h=1
	If w=0 then	w=1
	m_height=h
	m_width=w
	m_bpp=bpp
	m_pixdata=New UByte[m_width*m_height*(m_bpp\8)]
End Constructor
Destructor texture_t

End Destructor
Sub texture_t.LoadBMP(filename As string)
	Dim img As UByte Ptr
	Dim pixdata As UByte Ptr
	Dim As UInteger h,w,bpp
	
Dim As Integer ff = Freefile    'Anfrage welcher bertragungsweg ist frei?
Open filename For Input As #ff 'ffne die Datei zum lesen
Get #ff, 19, w              'Breite aus der BMP-Datei auslesen
Get #ff, 23, h               'Hhe aus der BMP-Datei auslesen
'Get #ff, 29, bpp               'Hhe aus der BMP-Datei auslesen
Close #ff                       'schliee die Datei
	img=ImageCreate(w,h,0,32)'bpp)
	BLoad(filename,img)
	ImageInfo(img,w,h,bpp,,pixdata)
	m_height=h
	m_width=w
	m_bpp=32
	m_pixdata=New UByte[m_width*m_height*(m_bpp\8)]
	For i As UInteger=0 To w*h*4-4 Step 4
				m_pixdata[i+3]=pixdata[i+3]
				m_pixdata[i+2]=pixdata[i+2]
				m_pixdata[i+1]=pixdata[i+1]
				m_pixdata[i+0]=pixdata[i+0]				
	Next
	ImageDestroy img
	img=0
End Sub
Sub texture_t.LoadTGA(filename As string)

End Sub


Function texture_t.GetHeight() As UInteger
	Return m_height
End Function
Function texture_t.GetWidth() As UInteger
	Return m_width
End Function
Function texture_t.GetDepth() As UInteger
	Return m_bpp\8
End Function
Function texture_t.GetPixData() As UByte Ptr
	Return m_pixdata
End Function

#EndIf