#Ifndef vertex_3d_t
#Define vertex_3d_t
Type vertex_3d
	m_pos As vector_4d 	
	
	Declare Constructor ()
	Declare Constructor (x As Single,y As Single,z As Single, w As Single)
	Declare Constructor (v As vector_4d)
	Declare Destructor ()

	Declare Function 	toString() As String
	Declare Function	TriangleAreaTimesTwo(b As vector_3d,c As vector_3d) As Single

End Type
Constructor vertex_3d()
	m_pos.x=0
	m_pos.y=0
	m_pos.z=0
	m_pos.w=0
End Constructor
Constructor vertex_3d(x As Single,y As Single,z As Single, w As Single)
	m_pos.x=x
	m_pos.y=y
	m_pos.z=z
	m_pos.w=w
End Constructor
Constructor vertex_3d(v As vector_4d)
	m_pos.x=v.x
	m_pos.y=v.y
	m_pos.z=v.z
	m_pos.w=v.w
End Constructor
Destructor vertex_3d()

End Destructor
Function	vertex_3d.TriangleAreaTimesTwo(b As vector_3d,c As vector_3d) As Single
	Dim x1 As Single = b.x-x
	Dim y1 As Single = b.y-y
	Dim x2 As Single = c.x-x
	Dim y2 As Single = c.y-y
	
	Return (x1*y2-x2*y1)
End Function
Function vertex_3d.toString() As String
Return  " " & m_pos.x & " " & m_pos.y & " " & m_pos.z & " " & m_pos.w
End Function
#EndIf