#Ifndef mesh_t_bi
#Define mesh_t_bi

Type mesh_t
	verts As vertex_t Ptr
	faces As face_t Ptr
	num_faces As UInteger
	num_vertexes As UInteger
	cur_vertex As UInteger
	cur_face As UInteger
	
	Declare Constructor()
	Declare Constructor(numVertexes As UInteger,numfaces As uinteger)
	Declare Destructor()

	Declare Sub addVertex(v As vertex_t)
	Declare Sub addFace(f As face_t)
	Declare Sub render(renderer As rendercontext_t,transform As matrix_4d,tex As texture_t Ptr)

End Type
Constructor mesh_t()
num_faces=0
num_vertexes=0
verts=0
faces=0
cur_face=0
cur_vertex=0
End Constructor
Constructor mesh_t(numVertexes As UInteger,numfaces As UInteger)
num_faces=numfaces
num_vertexes=numvertexes
verts=New vertex_t[num_vertexes]
faces=New face_t[num_faces]
cur_face=0
cur_vertex=0
End Constructor
Destructor mesh_t()
Delete [] verts
Delete [] faces
num_faces=0
num_vertexes=0
cur_face=0
cur_vertex=0
End Destructor
Sub mesh_t.addVertex(v As vertex_t)
	verts[cur_vertex]=v
	cur_vertex+=1	
End Sub
Sub mesh_t.addFace(f As face_t)
	faces[cur_face]=f
	cur_face+=1
End Sub

Sub mesh_t.render(renderer As rendercontext_t,transform As matrix_4d,tex As texture_t ptr)
	For i As UInteger=0 To num_faces-1
		renderer.FillTriangle(verts[faces[i]->A].Transform(transform),verts[faces[i]->B]->Transform(transform),verts[faces[i]->C]->Transform(transform),tex)
	Next
End Sub

#endif